open Message

type map = {
  cop_names: string array;
  control: int array;
}

let init names =
  { cop_names = names;
    control = Array.mapi (fun i _ -> i) names }

exception Found of int

let cop_num m name =
  try 
    Array.iteri (fun i n -> if n = name then raise (Found i)) m.cop_names;
    Printf.eprintf "!!!! Cop name not found !!!!\n";
    0
  with Found i -> i

let brains m =
  let l = ref [] in
  Array.iteri (fun i b -> if (i=b) then l := i :: !l ) m.control;
  !l

let controled_by m j =
  if m.control.(j) = j then (
    let l = ref [] in
    Array.iteri (fun i b -> if (j=b) then l := i :: !l ) m.control;
    !l
  ) 
  else []

let controller m name = m.control.(cop_num m name)
let controller_i m i = m.control.(i)

let cop_name m i = m.cop_names.(i)

let integrate m scs =
  let l = ref [] in
  List.iter
    (fun sc ->
       let brain_no = cop_num m sc.sc_brain
       and cop_no = cop_num m sc.sc_cop in
       let old_brain = m.control.(cop_no) in
       if old_brain <> brain_no then (
	 if (old_brain = cop_no) then l := (old_brain, brain_no) :: !l;
	 m.control.(cop_no) <- brain_no;
       )
    )
    scs;
  !l

let is_active m i = m.control.(i) = i
