open Message 
open Topology

(* On envoie deux types d'infos:
   - avec certitude 100, les evidences qu'on vient de trouver
   - avec certitude -100, les cases ou on est sur que le voleur
     ne se trouve pas. *)

let compute_inform info world =
  let topo = Info.topo info in
  let not_there = NS.diff topo.all_nodes (Info.get_certain info) in
  let posinfo ev =
    {
      inf_bot = topo.robber_name; 
      inf_loc = ev.ev_loc;
      inf_ptype = Robber;
      inf_world = ev.ev_world;
      inf_certainty = 100;
    } in
  let neginfo n = 
    {
      inf_bot = topo.robber_name; 
      inf_loc = n.nod_loc;
      inf_ptype = Robber;
      inf_world = Info.current_world info;
      inf_certainty = -100;
    } in
  List.map posinfo world.wor_evs @
  List.map neginfo (NS.elements not_there) 
