(* $Id: damien_cop.ml,v 1.28.4.1 2005/07/10 09:08:48 frisch Exp $ *)

open Message
open Printf
open Topology

let damien_cop me env w () =
  let info = env.Cops_api.env_info in
  env.Cops_api.env_info <- Info.change_cop info (Planify.change_cops_move_type info);
    (* Changement de moyen de locomotion *)

  let info = env.Cops_api.env_info in
  let topo = env.Cops_api.env_topo
  and drawer = env.Cops_api.env_drawer in

  let infos = Cop_informer.compute_inform info in

  let _informs = Cops_api.cop_inform me env infos in
(*
    eprintf "set sizes = %d %d\n"
      (NS.cardinal (Info.get_possible info))
      (NS.cardinal (Info.get_certain info));
    flush stderr;
*)
    Draw.display_node_sets drawer
      (Info.get_possible info)
      (Info.get_certain info);

    let my_move,plan = Planify.damien_plan info in
    let _plans = Cops_api.cop_plan me plan in

  (*
    let myvote =
      let cops = Array.to_list topo.cops_name in
      let pref x y =
        if x = topo.name then -1 else if y = topo.name then 1 else 0
      in
      List.sort pref cops
    in *)
  let vote_res = Cops_api.cop_vote me (Voting.vote topo.name) in
  Voting.count vote_res;
    (my_move, ()) 

let () =
  Cops_api.register_cop "damien_cop"
    { cops_init = (fun _ env -> Voting.init env.Cops_api.env_wsk);
      Cops_api.cops_job  = damien_cop;
      Cops_api.cops_ptype = Cop_foot;
    }
