(* $Id: distance.ml,v 1.3 2005/06/27 13:11:44 frisch Exp $ *)

(* Calcul des distance sur un graphe orient avec distances 1 sur aretes *)

type 'a graph = int list array

let distance_from_set a s =
  let n = Array.length a in
  let d = Array.create n (-1) in

  let rec aux i = function
    | [] -> ()
    | l ->
	let next = ref [] in
	List.iter
	  (fun n1 ->
	     List.iter 
	       (fun n2 -> if d.(n2) < 0 then (d.(n2) <- i; next := n2 :: !next))
	       a.(n1)
	  )
	  l;
	aux (succ i) !next
  in

  List.iter (fun i -> d.(i) <- 0) s;
  aux 1 s;
  d

let distance a i = distance_from_set a [i]

let distances a =
  Array.init (Array.length a) (fun i -> lazy (distance a i))



let leq_n a nmax s f =
  let n = Array.length a in
  let d = Array.create n (-1) in

  let rec aux i = function
    | [] -> ()
    | l ->
	if (i <= nmax) then 
	  let next = ref [] in
	  List.iter
	    (fun n1 ->
	       List.iter 
		 (fun n2 -> 
		    if d.(n2) < 0 
		    then (f n2; d.(n2) <- i; next := n2 :: !next))
		 a.(n1)
	    )
	    l;
	  aux (succ i) !next
  in

  List.iter (fun i -> d.(i) <- 0; f nmax) s;
  aux 1 s

