(* $Id: distance.mli,v 1.2 2005/06/27 08:10:23 frisch Exp $ *)

(* Calcul des distance sur un graphe orient avec distances 1 sur aretes *)

type 'a graph = int list array

val distance: 'a graph -> int -> int array
  (** [distance graph i] : tableau des distances depuis le sommet i.
      (-1) pour sommets non accessibles *)

val distances: 'a graph -> int array Lazy.t array


val distance_from_set: 'a graph -> int list -> int array

val leq_n: 'a graph -> int -> int list -> (int -> unit) -> unit
  (* Call a function for each node at distance <= n than a set
     of nodes *)
