(* $Id: fw.mli,v 1.7 2005/06/26 21:11:42 regisgia Exp $ *)

(* Floyd Warshall *)
type fw

type fw_next_step = {
  fns_next        : int;
  fns_ptype_one   : Message.ptype;
  fns_ptype_final : Message.ptype;
}

val init_fw : Topology.topo -> fw

val shortest_path_next_step :
  fw -> Message.ptype -> node_from:int -> node_to:int ->
  Misc.F_INT.f_int * fw_next_step option

val dump_shortest_path :
  fw -> Topology.topo -> Message.ptype ->
  node_from:int -> node_to:int ->
  string

(* Calcul des positions potentiellement occupables par un voleur au
 * bout d'un nombre donné de tours *)
type witr_cont

val witr_cont : Topology.topo -> robber_loc:int -> witr_cont

val where_is_the_robber :
  cops:Misc.IntSet.t -> nturns:int -> witr_cont -> witr_cont

val where_is_the_robber_cops_are_moving :
  cops:Misc.IntSet.t list -> witr_cont -> witr_cont

val witr_topo   : witr_cont -> Topology.topo
val witr_robber : witr_cont -> Misc.IntSet.t
