(* $Id: robber1.ml,v 1.4.4.6 2005/07/10 12:07:17 lefessan Exp $ *)

open Args
open Message
open Robber_types
open Robber_topology
open Robber

open Graphics

let init t = ()

let inform t w =   
  let edges = Array.of_list t.foot_edges.(t.robber_node) in
  t.proposed_robber_node <- edges.(Random.int (Array.length edges));
  []

let planning t s infs = 
  Robber_planning.planning t s
  
let voting t w from_plan =  
  Robber_planning.voting t from_plan

let waiting t w vote_res = 
  Robber_planning.count vote_res;
  Robber_bribing.waiting t w
  
let moving t w offered_cops = 
  Robber_bribing.moving t w offered_cops
  
let basic_robber = 
  {
    robber_init = init;
    robber_inform = inform;
    robber_planning = planning;
    robber_voting = voting;
    robber_waiting = waiting;
    robber_moving = moving;
    robber_sumcops = Robber_misc.sum_to_cops1;
    robber_bribe =  BribeClosest 2;
  }
  
let _ = 
  register_robber "robber1" 
    "random robber"
  basic_robber
