(* $Id: robber11.ml,v 1.2.2.6 2005/07/10 12:07:17 lefessan Exp $ *)

open Args
open Message
open Robber_types
open Robber_topology
open Robber

let can_bribe = ref true
let did_bribe = ref false
  
let waiting t s vote_res =
  if s.state_known || s.state_num > 190 then can_bribe := true;
  if !can_bribe then did_bribe := t.stolen > 50;
  if !did_bribe then Bribe else Nobribe
    
let moving t s offered =
  if !did_bribe then begin
      Printf.fprintf stderr "DID BRIBE: MUST CHOOSE...\n"; flush stderr;
      Robber_bribing.moving t s offered;
      did_bribe := false;
(* Do it only once *)
      can_bribe := false
    end
    
let _ = 
  register_robber "robber11" 
  "same as robber9 with sum_to_cops v2 and bribing forced"
    { 
    Robber1.basic_robber with
    robber_inform = Robber9.inform;
    robber_waiting = waiting;
    robber_moving = moving;
    robber_sumcops = Robber_misc.sum_to_cops2;
    robber_bribe = BribeOften;
  }
  