(* $Id: robber_types.ml,v 1.1.2.1 2005/07/10 12:07:17 lefessan Exp $ *)

open Args
open Message

type bribe_strategy =
  BribeClosest of int 
| BribeOften
  
type node_type = 
  Bank of bank
| Hq
| Robber_start
| Ordinary
  
and node = {
    node_num : int; 
    node_loc : string;
    node_x : int;
    node_y : int;
    mutable node_tag : node_type;
    mutable node_danger : int;
    mutable node_density : int;
    
    mutable node_copsum : int;
    mutable node_bankdist : int;
    mutable node_copdist : int;
  }

and bank = {
    bank_num : int;
    bank_node : int;
    mutable bank_value : int;
  }
  
type map = {
    mutable nbanks : int;
    mutable ncops : int;
    
    mutable our_name : string;
    mutable robber_name : string;
    mutable cops_names : string array;
    cop_by_name : (string, int) Hashtbl.t;
    
    mutable nodes : node array;
    mutable node_by_loc : (string, node) Hashtbl.t ;
    
    mutable initial_robber_node : int ;
    
    mutable initial_cop_node : int ;
    mutable cop_node : int ;
    mutable cop_ptype : Message.ptype ;
    
    
    mutable last_robber_node : int;
    mutable proposed_robber_node : int;
    mutable proposed_robber_bribe : bribe_result;
    mutable robber_node : int ;
    
    mutable banks : bank array ;
    mutable banks_nodes : Intset.t;
    mutable car_edges : int list array ;
    mutable foot_edges : int list array ;
    
    
    
    mutable  car_adj : int array array;
    mutable foot_adj : int array array;
    
    mutable car_dist : int array array;
    mutable foot_dist : int array array;
    
    
    mutable last_robbery : int;
    mutable last_robbery_time : int;
    mutable robberies : int;
    mutable stolen : int;
    
    mutable states : state list;
  }


and state = {
    state_robber : robber;
    state_num : int;
    mutable cops_nodes : int array;
    mutable cops_ptypes : ptype array;
    mutable cops_bribed : bool array;
    bank_foot_cops : int array array;
    bank_car_cops : int array array;
    bank_all_cops : int array array;
    
    mutable state_robbernode : int;
    mutable state_possibles : bool array;
    mutable state_known : bool;
    mutable state_messages : string list;
  }

and robber = {
    robber_init : (map -> unit);
    robber_inform : (map -> state -> inf list);
    robber_planning : ( map -> state -> (string * inf list) list -> plan list);
    robber_voting : ( map -> state -> (string * plan list) list -> vote list);
    robber_waiting : ( map -> state -> vote_res -> bribing);
    robber_moving : (map -> state -> offered_cops -> unit) ;
    robber_sumcops : (map -> state -> int -> int);
    robber_bribe : bribe_strategy;
  }
  
