exception Timeout

let timeouts = ref true

let timeout n msg arg ~normal ~timedout =
  if not !timeouts then normal arg
  else
    let f = 
      Sys.signal 
	Sys.sigalrm (Sys.Signal_handle (fun _ -> raise Timeout)) in
    try
      ignore (Unix.alarm n);
      let r = normal arg in
      ignore (Unix.alarm 0);
      ignore (Sys.signal Sys.sigalrm f);
      r
    with Timeout ->
      ignore (Unix.alarm 0);
      ignore (Sys.signal Sys.sigalrm f);
      Printf.eprintf "Timeout: %s\n" msg;
      timedout arg

