(* $Id: voting.ml,v 1.3.4.5 2005/07/10 11:00:00 frisch Exp $ *)

open Message

type t = (string * int ref) list

let init world =
  List.map (fun n -> (n, ref 0)) world.wsk_cops

let count t = function
  | Nowinner ->
      ()
  | Winner w ->
      try
	incr (List.assoc w t)
      with Not_found ->  (* This should not occur, but still... *)
        ()

let vote t name names =
  let scores = List.map 
    (fun n ->
       n,
       if n = name then (-1000) (* force this name to be first *)
       else
	 try !(List.assoc n t)
	 with Not_found -> 0) names in
  let sorted = 
    List.sort 
      (fun (_, score) (_, score') -> score' - score)
      scores in
  List.map fst sorted
  

